@import 'src/style/includes/sass_vars_and_mixins.module.scss';


.chartFrame {
  display: grid;
}

.head {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  flex-wrap: wrap;
  align-items: baseline;
  margin-bottom: var(--space-s);

  &.hasDescription {
    margin-bottom: var(--space-s);
    //align-items: flex-end;
    //flex-direction: row;

    .controls {
      margin-top: var(--space-m);
    }
  }

  &.compact {
    margin-bottom: 0;
    flex-direction: row;

    .titles {
      display: flex;
      vertical-align: baseline;
    }
  }
}

.headTop {
  display: flex;
  flex-direction: column;

  @include smaller-than-s {
    align-items: flex-start;
    margin-bottom: var(--space-xs);
  }
}

.titles {
  margin-right: var(--space-m);
  margin-bottom: var(--space-xxs);
}

.title {
  font-size: var(--font-size-s);
  margin: 0;
  margin-right: var(--space-xxs);
  line-height: 1.1em;
}

.subtitle {
  margin: 0;
  font-size: var(--font-size-s);
  font-weight: 400;
  color: var(--color-text-weaker);
  line-height: 1.1em;
}

.metaButtons {
  display: flex;
  flex-wrap: nowrap;
}

.metaButton {
  margin-right: var(--space-m);
}

.chartCaption {
  margin-top: calc(-1 * var(--space-s));
  //font-size: var(--font-size-s);
  color: var(--color-text-weaker);
  line-height: var(--font-line-height-tighter);
  margin-bottom: 0;

  max-width: 35em;
  min-width: 50%;

  p {
    margin-bottom: 0;
  }

  @include smaller-than-s {
    max-width: unset;
  }
}

.infoTray {
  max-width: 30em;
  padding: var(--space-xxs) var(--space-s);
  padding-bottom: 0;
  font-size: var(--font-size-s);
}

.infoTraySection {
  margin-bottom: var(--space-s);
  margin-top: 0;

  &:last-child {
    margin-bottom: 0;
  }
}

.infoTraySectionTitle {
  font-size: var(--font-size-s);
  margin-bottom: 0;
}

.infoTrayItem {
  margin-bottom: var(--space-xxs);
  line-height: var(--font-line-height-tighter);

  a {
    font-weight: 500;
  }
}

.controls {
  //margin-top: var(--space-xxs);

  @include smaller-than-s {
    margin-bottom: var(--space-xxs);
  } 
}

.control {
  margin-right: var(--space-l);

  &:last-child {
    margin-right: 0;
  }

  @include smaller-than-s {
    margin-right: 0;
    margin-bottom: var(--space-xxs);
  }
}

.footer {
  display: flex;
  justify-content: space-between;
  padding-top: var(--space-xxs);
  font-size: var(--font-size-s);

  &.hasDisclaimers {
    justify-content: flex-start;
  }

  &.hasButtons:not(.hasDisclaimers):not(.hasTitle) {
    border-top: none;
    padding-top: 0;
  }

  &.hasDisclaimers.hasButtons {
    flex-direction: column;
  }

  &.hasTitle.hasButtons {
    justify-content: space-between;
  }

  @include smaller-than-s {
    display: block;
    padding-top: var(--space-xs);
  }
}

.disclaimers {
  margin: 0;
  max-width: 40em;
  line-height: var(--font-line-height-tighter);
  color: var(--color-text-weaker);
  margin-bottom: var(--space-xxxs);
}

// CHART
.svg {
  overflow: visible;
}

.tick {
  pointer-events: none;
  &.x {
    .tickLabel {
      text-anchor: middle;
    }

    &.first {
      .tickLabel {
        text-anchor: start;
      }
    }
    &.last {
      .tickLabel {
        text-anchor: end;
      }
    }
  }
}

.highlight {
  opacity: 1 !important;
}

.tickLabel {
  font-size: var(--font-size-xs);
  fill: var(--color-text-weaker);
}

.tickLine {
  shape-rendering: crispEdges;
  stroke: var(--color-foreground-weakest);
  stroke-dasharray: 1 2;

  &.major {
    stroke: var(--color-foreground-weaker);
  }

  &.highlighted {
    stroke: var(--color-foreground-weaker);
    stroke-width: 1;
    //stroke-dasharray: 2 1;
  }
}

.label {
  font-size: var(--font-size-s);
  fill: var(--color-text-weaker);
  color: var(--color-text-weaker);
  line-height: 1.1em;

  &.primary {
    font-weight: 500;
    fill: var(--color-text-base);
    color: var(--color-text-base);
    font-size: var(--font-size-s);
  }
}

// Wrapper for each chart svg for sizing
.chartWrapper {
  position: relative;
  transition: opacity 0.078s;

  &.accommodateYAxis {
    @include smaller-than-s {
      margin-left: var(--space-m);
    }
  }
}

// LEGEND
.legend {
  display: flex;
  flex-wrap: wrap;
  font-size: var(--font-size-s);
  color: var(--color-text-weaker);
  margin-bottom: var(--space-m);
  margin-top: var(--space-xs);
}

.legendItem {
  list-style: none;
  margin-top: 0;
  margin-bottom: 0;
  line-height: var(--font-line-height-base);
  margin-right: var(--space-s);
  display: flex;
  align-items: center;  

  &.line .legendItemMark {
    transform: rotate(-45deg);
  }

  @include smaller-than-s {
    margin-bottom: 2px;
  }
}

.legendItemMark {
  margin-right: 0.3em;
  overflow: visible;

  width: 11px;
  height: 11px;



  @include smaller-than-s {
    width: 10px;
    height: 10px;
    margin-right: 0.25em;
  }
}

// MARKS

.legend {
  .markLine {
    shape-rendering: crispEdges;
  }

  .markBar {
    shape-rendering: unset;
  }
}

.markArea {
  fill: var(--color);
  fill-opacity: 0.3;
}

.markAreaOutline {
  stroke-opacity: 0.15;
  fill: transparent;
}

.barSeparator {
  fill: #fff;
  shape-rendering: crispEdges;
}

.markBar {
  shape-rendering: crispEdges;
  opacity: 0.95;
}

.markLine {
  stroke-width: 2.5;

  &.dashed {
    stroke-dasharray: 1 5;
    stroke-width: 2.2;
    shape-rendering: unset;
    stroke-linecap: round;
  }
}

@keyframes fade-out {
  0% {
    opacity: 1;
  }

  70% {
    opacity: 0;
    transform: scale(3);
  }

  100% {
    opacity: 0;
    transform: scale(3);
  }
}

.markForeground {
  stroke-opacity: 0.9;
  fill-opacity: 0.6;
  stroke-width: 1;

  &.interactive {
    animation: fade-out 1.5s infinite;
  }
}

.markBackground {
  stroke: rgba(white, 0.9);
  fill: rgba(white, 0.9);
  stroke-width: 5;
}

.yRuler {
  shape-rendering: crispEdges;
  stroke-dasharray: 1 2;
}
